package
{
	import com.tbs.drag.DragableItem;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.filters.GlowFilter;
	import flash.utils.getDefinitionByName;
	
	public class DragItemSimple extends DragableItem
	{
		private var _index:int;
		private var _iconIndex:int;
		private var block:MovieClip;
		private var icon:Bitmap;
		
		private static var dragAcceptGlow:GlowFilter = new GlowFilter(0xffff);
		private static var dragRejectGlow:GlowFilter = new GlowFilter(0xff0000);
		
		public function DragItemSimple(index:int, iconIndex:int)
		{
			addChild(block = new (getDefinitionByName("DragbleItemBlock" + int(index / 10)) as Class));
			block.container.addChild(icon = new Bitmap());
			_index = index;
			this.iconIndex = iconIndex;
			
			super();
			
			dragable = true;
			
		}
		
		public function get index():int
		{
			return _index;
		}
		
		override protected function get dragAvatar():BitmapData
		{
			return icon.bitmapData;
		}
		
		
		public function get iconIndex():int
		{
			return _iconIndex;
		}
		
		public function set iconIndex(value:int):void
		{
			_iconIndex = value;
			
			var c:Class = getDefinitionByName("lol" + _iconIndex) as Class;
			icon.bitmapData = new c();
		}
		
		override protected function addEffect(isAccept:Boolean=true):void
		{
			super.addEffect(isAccept);
			this.filters = [isAccept ? dragAcceptGlow : dragRejectGlow];
		}
		
		override protected function removeEffect():void
		{
			super.removeEffect();
			this.filters = [];
		}
		
		override protected function dragDrop(itemSrc:DragableItem):void
		{
			super.dragDrop(itemSrc);
			
			var ind:int =  itemSrc["iconIndex"];
			itemSrc["iconIndex"] = this.iconIndex;
			this.iconIndex = ind;
		}
		
		override protected function dragEnter(itemSrc:DragableItem):Boolean
		{
			var _itemSrc:DragItemSimple = itemSrc as DragItemSimple;
			return int(_itemSrc.index / 10) == int(index / 10);
		}
		
		
	}
}